//package scenario_viewer;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.table.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.universe.PlatformGeometry;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.geometry.Box;/*ѤߤBoxѤ뤿*/
import com.sun.j3d.loaders.*;
import com.sun.j3d.loaders.vrml97.*;
import Stage3D.*;
import Stage3D.utils.*;
import Actors.*;
import DataPack.*;

public class SceneKitchen extends JFrame
{
	//JPanel contentPane;
	StagePanel stagepanel;
	JScrollPane msgPane;
	JTextArea msgArea;

	/* ե졼ι */
	public SceneKitchen()
	{
		stagepanel = new StagePanel();
		msgArea = new JTextArea();
		msgPane = new JScrollPane(msgArea,
								  JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
								  JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		//getContentPane().setLayout(null);
		this.setSize(500, 400);
		this.setTitle("scenario_viewer");
        makeLayout();
		msgArea.setEditable(false);
		stagepanel.setMsgArea(msgArea);
		stagepanel.init();
	}
	private void makeLayout()
	{
		Container pane = getContentPane();
		//pane.setPreferredSize(new Dimension(0,0));
		stagepanel.setPreferredSize(new Dimension(0,0));
		msgArea.setPreferredSize(new Dimension(200,0));

		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		pane.setLayout(gbl);
		gbc.fill = GridBagConstraints.BOTH;

		gbc.gridx=0; gbc.gridy=0;
		gbc.weightx=1; gbc.weighty=1;
		gbl.setConstraints(stagepanel,gbc);

		gbc.gridx=1; gbc.gridy=0;
   		gbc.weightx=0; gbc.weighty=1;
		gbl.setConstraints(msgArea,gbc);

		pane.add(stagepanel);
		pane.add(msgArea);

	}
	public void show()
	{
		super.show();
	}
	/* ɥĤ줿˽λ褦˥С饤 */
	protected void processWindowEvent(WindowEvent e)
	{
		super.processWindowEvent(e);
		if(e.getID() == WindowEvent.WINDOW_CLOSING)
			{
				System.exit(0);
			}
	}
	public static void main(String[] args)
	{
		SceneKitchen w = new SceneKitchen();
		w.show();
		//w.makeLayout();
	}
}

class StagePanel extends JPanel
{
	JTextArea msgArea = null;
	private VirtualUniverse virtualuniverse = new VirtualUniverse();
	private Stage universe = null;	/* SimpleUniverse */
	private CameraMan StageCameraMan;

	//===================================================================
	//Υ֥åϲư˴طƤʤǤԤΥץĤƤΤǻĤƤ뤬
	//ƤϤʤ
	ObjInfo boy = null;	//ǯξ
	ObjInfo mother = null;	//Ƥξ
	Transform3D oldtmpT3d = null;	//ưνλΥΰ֤ݻ
	ObjInfo oldObjInfo = null;	//ưξݻ
	//===================================================================
		
	/* ץåȤν */
	public StagePanel()
	{
		GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
		Canvas3D canvas = new Canvas3D(config);
		this.setLayout(new BorderLayout());
		this.add(canvas, BorderLayout.CENTER);
		universe = new Stage(virtualuniverse,100);
		//ɲ
		SimpleCameraMan camera = new SceneCameraMan();
		camera.getView().addCanvas3D(canvas);
		universe.setStageCameraMan(camera);
        View v = camera.getView();
        v.setFieldOfView(2);
        v.setFrontClipDistance(0.03);
        camera.setCamViewPoint(new Vector3d(0,5,0));
        camera.setCamViewLock(true);
        camera.setCamTargetPoint(new Vector3d(0,0,0));
        camera.setCamTargetLock(true);
        camera.setCameraMode(camera.PURSUITTARGET);
	}
	public void init()
	{
		String ScenarioName = "scenario.txt";
		universe.setActorType("Boy",Boy.class);
		universe.setActorType("Mother",Mother.class);
		universe.setActorType("Door",Door.class);


		//ʥꥪɤ߹	
		String tmp;
		try
		{
			BufferedReader filereader = new BufferedReader(new FileReader(ScenarioName));
			DataPack dp;
			StringParser sp = new StringParser();
			while ((tmp=filereader.readLine())!=null)
				{
					//throwEvent(tmp);
					//System.out.println(tmp);
					if (tmp.indexOf("#")==0 || tmp.length()==0) continue;
					dp = sp.convertString(tmp);
					//System.out.println(tmp);
					if (dp!=null)
					{
						//System.out.println(dp.toString());
						universe.execCommand(dp);
					}
				}		
		}catch(IOException e)
		{
		}
		//universe.readScenario("scenario.txt");

		StageCameraMan = universe.getStageCameraMan();
				
		//
		universe.addBranchGraph(createScene());
		//󳫻
		universe.start();
	}

	public void setMsgArea(JTextArea value)
	{
		msgArea = value;
	}

//================================================================
//ΥѤΥ
//================================================================
	class SceneCameraMan extends SimpleCameraMan
	{
        CameraManAI cmai = new MyCameraManAI();
		public void catchEvent(DataPack dp)
		{
			//ä٥Ȥsayʤ餽Ƥɽơ
			//ưActor褦ˤ롣
            
			String[] sds = dp.getStringData();
			DataPack[] dps = dp.getDataPack();
			if (sds.length >= 2 && sds[0].equals("say") && dps.length > 0)
			{
				DataPack adp = dps[0];
				int[] aid = adp.getIntData();
				String[] asd = adp.getStringData();
				if (aid.length >= 3)
				{
					if (aid[2]==1)
					{
						if (asd.length < 2) return;
						msgArea.append(sds[1]+">"+asd[0]+":"+asd[1]+"\n");
					}else if (aid[2]==2)
					{
						if (asd.length < 1) return;
						msgArea.append(sds[1]+":"+asd[0]+"\n");
					}
				}
			}else{
				System.out.println(dp.toString());
			}
		}
        /* old
		public void doActing()
		{
			super.doActing();
			//ƤƤоݤsayλ
			if (CamTargetActor!=null)
			{
				if (CamTargetActor.getStatus("say") == null)
				{
					CamTargetPoint = CamTargetActor.getPosition();
					CamTargetActor = null;
					
				}
			}
		}
        */
        public void doActing()
        {
            cmai.UpdateCameraMan(universe.getActors(),this);
            super.doActing();
        }
	}

//================================================================
//ʲǤԤΥץʥΤߡ
//================================================================
	private BranchGroup createScene() //κ
	{
		//BranchGroupΥ󥹥
		BranchGroup root = new BranchGroup();
				
		//ưϰϤȾ100εΰ
		BoundingSphere bounds = new BoundingSphere(new Point3d(), 100.0);
				
		//
				
		//Ķ
		AmbientLight alight = new AmbientLight();
		alight.setInfluencingBounds(bounds);
		root.addChild(alight);

		//Τ˹ߤʿԸʵۡ
		DirectionalLight light = new DirectionalLight(new Color3f(0.75f, 0.75f, 0.75f),
													  new Vector3f(0.57f, -0.57f, -0.57f));
		light.setInfluencingBounds(bounds);
		root.addChild(light);

		//ŵ
		PointLight denkyu = new PointLight(new Color3f(0.9f, 0.9f, 0.9f),
										   new Point3f(3.5f, 1.5f, 2.5f),
										   new Point3f(1.0f, 0.0f, 0.0f) );
				
		PointLight denkyu2 = new PointLight(new Color3f(0.9f, 0.9f, 0.9f),
											new Point3f(5.3f, 1.6f, 4.0f),
											new Point3f(1.0f, 1.0f, 1.0f) );
				
		denkyu.setInfluencingBounds(bounds);
		root.addChild(denkyu);
				
		denkyu2.setInfluencingBounds(bounds);
		root.addChild(denkyu2);
				
		//Τ֤ˤäƺɸƥ
		//root.addChild(createSphere(5.3, 1.6, 4.0, 0.5f));
				
		//ɤ
				
		//ϭ
		//
		root.addChild(createRoukaWall(-2.1, 0.0, -2.0, 0.1, 3.0, 11.0));
		//̤
		root.addChild(createRoukaWall(-2.1, 0.0, -2.1, 11.1, 3.0, 0.1));
		//
		root.addChild(createRoukaWall(-2.1, 0.0, 9.0, 11.1, 3.0, 0.1));
				
		//
		//
		root.addChild(createWall(0.0, 0.0, 0.0, 0.1, 3.0, 1.5));
		root.addChild(createWall(0.0, 2.0, 1.5, 0.1, 1.0, 1.0));
		root.addChild(createWall(0.0, 0.0, 2.5, 0.1, 3.0, 0.3));
		root.addChild(createWall(0.0, 0.0, 2.8, 0.1, 1.0, 3.0));
		root.addChild(createWall(0.0, 2.2, 2.8, 0.1, 0.8, 3.0));
		root.addChild(createWall(0.0, 0.0, 5.8, 0.1, 3.0, 1.2));
		//̤
		root.addChild(createWall(0.0, 0.0, -0.1, 2.1, 3.0, 0.1));
		root.addChild(createWall(2.1, 0.0, -0.1, 4.0, 1.0, 0.1));
		root.addChild(createWall(2.1, 2.2, -0.1, 4.0, 0.8, 0.1));
		root.addChild(createWall(6.1, 0.0, -0.1, 1.1, 3.0, 0.1));
		//
		root.addChild(createWall(7.1, 0.0, 0.0, 0.1, 3.0, 7.0));
		//
		root.addChild(createWall(0.0, 0.0, 7.0, 7.2, 3.0, 0.1));

		//ŷ
		root.addChild(createTenjo()); //Ȥ椫鸫Ȥŷ
                                
		//γ0
		//root.addChild(createDoor(0.0, 0.0, 1.5, 0.05, 2.0, 1.0, 0.0));
                                
		//ơ֥
		root.addChild(createTable(2.6, 0.7, 2.0, 1.5, 0.05, 2.0));
                                
		//¢
		root.addChild(createFreez(1.1, 0.0, 6.0, 1.0, 2.5, 1.0));
		root.addChild(createFreezDoor(1.1, 0.0, 5.9, 1.0, 1.49, 0.1, 0.0));//
		root.addChild(createFreezDoor(1.1, 1.5, 5.9, 1.0, 1.0, 0.1, Math.PI/6.0));//
                                
		//¢˰ʳβȶ餷
		root.addChild(createFreez(2.15, 0.0, 6.0, 0.45, 2.5, 1.0));
		root.addChild(createFreezDoor(2.15, 0.0, 5.9, 0.45, 0.99, 0.1, 0.0));
		root.addChild(createFreezDoor(2.15, 1.0, 5.9, 0.45, 0.99, 0.1, 0.0));
		root.addChild(createFreezDoor(2.15, 2.0, 5.9, 0.45, 0.49, 0.1, 0.0));
                                
		root.addChild(createFreez(2.65, 0.0, 6.0, 4.4, 1.0, 1.0));
		root.addChild(createFreezDoor(2.65, 0.0, 5.9, 0.99, 0.99, 0.1, 0.0));
		root.addChild(createFreezDoor(3.65, 0.0, 5.9, 0.99, 0.99, 0.1, 0.0));
		root.addChild(createFreezDoor(4.65, 0.0, 5.9, 0.99, 0.99, 0.1, 0.0));
		root.addChild(createFreezDoor(5.65, 0.0, 5.9, 0.49, 0.99, 0.1, 0.0));
		root.addChild(createFreezDoor(6.15, 0.0, 5.9, 0.89, 0.99, 0.1, 0.0));
                                
		root.addChild(createFreez(2.65, 1.9, 6.2, 3.0, 1.0, 0.8));
		root.addChild(createFreezDoor(2.65, 1.9, 6.1, 0.59, 0.99, 0.1, 0.0));
		root.addChild(createFreezDoor(3.25, 1.9, 6.1, 0.59, 0.99, 0.1, 0.0));
		root.addChild(createFreezDoor(3.85, 1.9, 6.1, 0.59, 0.99, 0.1, 0.0));
		root.addChild(createFreezDoor(4.45, 1.9, 6.1, 0.59, 0.99, 0.1, 0.0));
		root.addChild(createFreezDoor(5.05, 1.9, 6.1, 0.59, 0.99, 0.1, 0.0));

		//ӵ
		root.addChild(createBox(6.35, 2.0, 6.6, 0.7f, 0.5f, 0.4f, 0.6f, 0.6f, 0.6f));
                                

		//Ȣ
		root.addChild(createCylinder(0.5, 0.0, 0.7, 0.15f, 0.5f, 0.0f, 0.5f, 0.5f));
                                
		//åסʤ餷Ρ
		//ǯΥå
		root.addChild(createCylinder(3.1, 0.75, 2.5, 0.03f, 0.15f, 0.5f, 0.6f, 0.7f));
		//ƤΥå
		root.addChild(createCylinder(3.6, 0.75, 3.5, 0.03f, 0.15f, 0.7f, 0.6f, 0.5f));

				
			//åͤξ
			root.addChild(createFloor());
			//åξ
			//root.addChild(createKitchinFloor());
				
			//
			root.addChild(createSky());

			//ޤ

			return root;
	}

//=================================================================
//ʲǤԤΥץ̤ܿʬư˴ؤäƤʤΤǺƤ
//=================================================================

    //оݤ
	private void choiceTarget(ObjInfo obj1, ObjInfo obj2)
	{
		double Imp1, Imp2;
		double sa1, sa2;

		Imp1 = estimateImportance(obj1);
		Imp2 = estimateImportance(obj2);
		sa1 = Imp1 - Imp2;
		sa2 = Imp2 - Imp1;

		//˽פȻפưʼ˲û
		if((0.0 < sa1 && sa1 <= 0.5 && Imp2 >= 3.0) || (0.0 < sa2 && sa2 <= 0.5 && Imp1 >=3.0) || (Imp1 == Imp2))
			{
				obj1.live = 1;	//ON
				obj2.live = 1;	//ON
			}
		else if(Imp1 > Imp2)
			{
				obj1.live = 1;	//ON
				obj2.live = -1;	//OFF
			}
		else if(Imp1 < Imp2)
			{
				obj1.live = -1;	//OFF
				obj2.live = 1;	//ON
			}
	}
		
	//оݤξ֤ʬϤƽ٤׻
	private double estimateImportance(ObjInfo obj)
	{
		double Imp = 0.0;	//
				
		//ùưǤꡢäǤ
		if(obj.talk == ObjInfo.	TALK_SPEAK)
			{
				Imp = Imp + 1.0;
				//˿Ѳ
				if(obj.heart > ObjInfo.HEART_OFF)
					{
						Imp = Imp + 3.0;
					}
			}
		//ùưǤꡢʹǤ
		else if(obj.talk == ObjInfo.TALK_HEAR)
			{
				Imp = Imp + 0.5;
				//˿Ѳ
				if(obj.heart > ObjInfo.HEART_OFF)
					{
						Imp = Imp + 3.0;
					}
			}
		//ùưǤϤʤ
		else
			{
				//Żưorưư򤷤Ƥ
				if(obj.action == ObjInfo.ACTION_STATIC || obj.action == ObjInfo.ACTION_DYNAMIC)
					{
						Imp = Imp + 1.0;
						//˿Ѳ
						if(obj.heart > ObjInfo.HEART_OFF)
							{
								Imp = Imp + 3.0;
							}
					}
			}
		return Imp;
	}

	class EyePointCalculateSystem
	{
		//оݤTGŪ˻֤
		//оݤTGɬ
		private TransformGroup setEyePoint(ObjInfo obj, ObjInfo subobj)
		{
			double x, y, z;

			TransformGroup targetTrans = new TransformGroup();
			//оݤTransformGroup
			targetTrans = obj.TG;

			Transform3D targetT3d = new Transform3D();
			//оݤTransform3D
			targetTrans.getTransform(targetT3d);
						
			Transform3D targetT3d_taihi = new Transform3D();
			//оݤTransform3D򤵤Ƥʸ̤ξǻѤ뤿
			targetTrans.getTransform(targetT3d_taihi);
						
						
			//֡оݴ֤ξ㳲ʪȽե饰ʥǥեȣȽ̵
			int atariHantei = 0;
			Transform3D tmpT3d = new Transform3D();
						
			do
				{
					//оݤTransform3D
					targetTrans.getTransform(targetT3d);
								
					tmpT3d = judgeT3d(targetT3d, obj, subobj, atariHantei);
								
					//λǡtargetT3d_taihiˤϻоݤTransform3DǼƤ
					//tmpT3dˤϥ֤Transform3DǼƤ
					Vector3d tarVec = new Vector3d();
					//оݤΰ֤Vector3d
					targetT3d_taihi.get(tarVec);
					Vector3d camVec = new Vector3d();
					//֤Vector3d
					tmpT3d.get(camVec);
								
								
					//桧0<=X<=7,  0<=Z<=7
					if((((0 <= camVec.x) && (camVec.x <= 7)) && ((0 <= camVec.z) && (camVec.z <= 7))) && 
					   (((0 <= tarVec.x) && (tarVec.x <= 7)) && ((0 <= tarVec.z) && (tarVec.z <= 7))))
						{
							atariHantei = 0;
						}
					//ϭ-2<=X<=0,  -2<=Z<=8
					else if((((-2 <= camVec.x) && (camVec.x <= 0)) && ((-2 <= camVec.z) && (camVec.z <= 8))) && 
							(((-2 <= tarVec.x) && (tarVec.x <= 0)) && ((-2 <= tarVec.z) && (tarVec.z <= 8))))
						{
							atariHantei = 0;
						}
					//ϭ˾ǯ˥餬㳰
					else if((((0 <= camVec.x) && (camVec.x <= 7)) && ((0 <= camVec.z) && (camVec.z <= 7))) && 
							(((-2 <= tarVec.x) && (tarVec.x <= 0)) && ((1.5 <= tarVec.z) && (tarVec.z <= 2.5))))
						{
							atariHantei = 0;
						}
					//̤ϭ-2<=X<=8,  -2<=Z<=0
					else if((((-2 <= camVec.x) && (camVec.x <= 8)) && ((-2 <= camVec.z) && (camVec.z <= 0))) && 
							(((-2 <= tarVec.x) && (tarVec.x <= 8)) && ((-2 <= tarVec.z) && (tarVec.z <= 0))))
						{
							atariHantei = 0;
						}
					else 
						{
							atariHantei++;
						}
				}
			while(atariHantei != 0);	//Ƚ̵꤬(atariHantei == 0)ˤʤޤ
						
			TransformGroup tmpTG = new TransformGroup();
			tmpTG.setTransform(tmpT3d);
						
			return tmpTG;
		}
				
		private Transform3D judgeT3d(Transform3D targetT3d_hikisu, ObjInfo obj, ObjInfo subobj, int atariHantei)
		{
			Transform3D targetT3d = targetT3d_hikisu;
			Transform3D tmpT3d = new Transform3D();
						
			//˻Ƥ
			if(obj.live == 1 && subobj.live == 1)
				{
					//оݡʥᥤˤTransform3D
					Transform3D objT3d = new Transform3D();
					obj.TG.getTransform(objT3d);
								
					//оݡʥᥤˤΰּ
					Vector3d objVec = new Vector3d();
					objT3d.get(objVec);
								
					//оݡʥ֡ˤTransform3D
					Transform3D subobjT3d = new Transform3D();
					subobj.TG.getTransform(subobjT3d);
								
					//оݡʥ֡ˤΰּ
					Vector3d subobjVec = new Vector3d();
					subobjT3d.get(subobjVec);
								
					Vector3d bothVec = new Vector3d();
					bothVec.x = (objVec.x + subobjVec.x) / 2.0;
					bothVec.y = (objVec.y + subobjVec.y) / 2.0;
					bothVec.z = (objVec.z + subobjVec.z) / 2.0;
					Transform3D bothT3d = new Transform3D();
					bothT3d.set(bothVec);
								
					//ĤλоݤTG
					TransformGroup bothTG = new TransformGroup();
					bothTG.setTransform(bothT3d);
								
					tmpT3d.setTranslation(new Vector3d(bothVec.x - objVec.x, bothVec.y - objVec.y, bothVec.z - objVec.z));
								
					//оݤTG򡢻оξԤޤǰư
					objT3d.mul(tmpT3d);
								
					//оݤTGĤλоݤTG˽񤭴
								
					double d = Math.sqrt((bothVec.x - objVec.x) * (bothVec.x - objVec.x) + (bothVec.z - objVec.z) * (bothVec.z - objVec.z));
								
					//εΥȾʬ * 3.5ΰ
					tmpT3d.setTranslation(new Vector3d(-3.5 * d, 0.0 ,0.0));
					objT3d.mul(tmpT3d);
								
					//֤ꤹ뤿˷³ե饰ΩƤ
					obj.keizoku = 1;
								
					return objT3d;
				}
			else
				{
					//åǤ
					if (obj.talk == ObjInfo.TALK_SPEAK || obj.talk == ObjInfo.TALK_HEAR)
						{
							//åǿѲ
							if (obj.heart > ObjInfo.HEART_OFF)
								{
									//оݤΥɸȤư֤
												
									//ܰڤΡܡ
									if (obj.heart == ObjInfo.HEART_DO)
										{
											//̤0.45 + Ĺ * 0.1 Ф᲼
											tmpT3d.setTranslation(new Vector3d(0.0, -0.15, 1.2 + obj.tSize * 0.1));
										}
									//ܰڤΡְ
									else if(obj.heart == ObjInfo.HEART_AI)
										{
											//̤0.45 + Ĺ * 0.1Ф夫
											tmpT3d.setTranslation(new Vector3d(0.0, 0.2, 1.2 + obj.tSize * 0.1));
										}
									//ܰڤΡִפȡֳڡ
									else
										{
											//̤0.45 + Ĺ * 0.1
											tmpT3d.setTranslation(new Vector3d(0.0, 0.0, 1.2 + obj.tSize * 0.1));
										}
								}
							//åǿѲ̵
							else
								{
									if (obj.who == ObjInfo.BOY)
										{
											//OTS(ۤå)˿Ĺ*0.147  ˿Ĺ*0.5
											//ξΤߡʹΰ֤ȤͤȤ
											tmpT3d.setTranslation(new Vector3d(-subobj.tSize*0.147, 0.06, -subobj.tSize*1.75));
										}
									else if(obj.who == ObjInfo.MOTHER)
										{
											tmpT3d.setTranslation(new Vector3d(-subobj.tSize*0.3, -0.275, -subobj.tSize*0.875));
										}
								}
						}
					//̾亮Ǥ
					else 
						{
							//̾亮оݤ礭
							if(obj.tSize > 2.0)
								{
									//ױ˿Ĺ*3.0 ̤˿Ĺ*3.0
									tmpT3d.setTranslation(new Vector3d(-obj.tSize*3.0, 2.0, obj.tSize*3.0));
								}
							else
								{
									//̾亮оݤưư򤷤Ƥ
									if (obj.action == ObjInfo.ACTION_DYNAMIC) 
										{
											//ưΥ7ʲǤ
											if (obj.idoukyori < 7.0)
												{
													//Ƚͤξ
													if (atariHantei == 0) 
														{
															//裱
															tmpT3d.setTranslation(new Vector3d(-obj.tSize*1.5, 0.0, obj.idoukyori+1.5));
														}
													//Ƚ˰ää
													else if(atariHantei == 1)
														{
															//裲
															tmpT3d.setTranslation(new Vector3d(-obj.tSize*0.5, 0.0, obj.idoukyori+1.5));
														}
													//֤ꤹ뤿˷³ե饰ΩƤ
													obj.keizoku = 1;
												}
											//ưΥ礭
											else
												{
													//˿Ĺ*1.5 ̤˿Ĺ*2.0 оʪȥȤεΥꤷоʪȤȤ˥ư
													tmpT3d.setTranslation(new Vector3d(-obj.tSize*1.5, 0.0, obj.tSize*2.0));
												}
										}
									//̾亮оݤŻư򤷤Ƥ
									else if(obj.action == ObjInfo.ACTION_STATIC)
										{
											//̾亮ǿѲ
											if (obj.heart > ObjInfo.HEART_OFF)
												{
													//оݤΥɸȤư֤
													//ܰڤΡܡ
													if (obj.heart == ObjInfo.HEART_DO) 
														{
															//̤ 0.45+Ĺ*0.1 Ф᲼
															tmpT3d.setTranslation(new Vector3d(0.0, -0.15, 1.2 + obj.tSize*0.1));
														}
													//ܰڤΡְ
													else if (obj.heart == ObjInfo.HEART_AI)
														{
															//̤ 0.9+Ĺ*0.1 Ф夫
															tmpT3d.setTranslation(new Vector3d(0.0, 0.25, 1.2 + obj.tSize*0.1));
														}
													//ܰڤΡִפȡֳڡ
													else
														{
															//̤ 0.45+Ĺ*0.1
															tmpT3d.setTranslation(new Vector3d(0.0, 0.0, 1.25 + obj.tSize*0.1));
														}
												}
											//̾亮оݤư˴Ѳ̵
											else
												{
													//ưоݤ̵
													if (obj.object == 0)
														{
															//̤ оݤοĹ*2.0
															tmpT3d.setTranslation(new Vector3d(0.0, 0.0, obj.tSize*2.0));
															//֤ꤹ뤿˷³ե饰ΩƤ
															obj.keizoku = 1;
														}
													//оʪ¸ߤƤƾ
													else if (obj.object < 0.5)
														{
															//̤ оݤοĹ*2.0
															tmpT3d.setTranslation(new Vector3d(0.0, 0.0, obj.tSize*2.0));
															//֤ꤹ뤿˷³ե饰ΩƤ
															obj.keizoku = 1;
														}
													//оʪ¸ߤƤ礭(⤵0.5mʾ)
													else if (obj.object >= 0.5)
														{
															//Ƚ꤬ͤλ
															if (atariHantei == 0)
																{
																	//˿Ĺ*0.7 оʪΤι⤵*1.5
																	tmpT3d.setTranslation(new Vector3d(-obj.tSize*0.7, 0.0, -obj.object*1.5));
																}
															//Ƚ꤬
															else if (atariHantei == 1)
																{
																	//˿Ĺ*2.3 оʪΤι⤵*0.53
																	tmpT3d.setTranslation(new Vector3d(-obj.tSize*2.3, 0.0, -obj.object*0.53));
																	//֤ꤹ뤿˷³ե饰ΩƤ
																	obj.keizoku = 1;
																}
														}
												}
										}
								}
						}
				}
						
			if(subobj.talk == ObjInfo.TALK_HEAR && obj.talk == ObjInfo.TALK_SPEAK &&
			   obj.heart == ObjInfo.HEART_OFF)
				{
					Transform3D tempT3d = new Transform3D();
					subobj.TG.getTransform(tempT3d);
					tempT3d.mul(tmpT3d);
					return tempT3d;
				}
			else if (oldObjInfo != null && obj.who == oldObjInfo.who && 
					 oldObjInfo.action == ObjInfo.ACTION_DYNAMIC && 
					 obj.talk == ObjInfo.TALK_OFF && 
					 obj.action == ObjInfo.ACTION_STATIC && 
					 obj.object == 0)
				{
					//Υ֤֤
					return oldtmpT3d;
				}
			else
				{
					Vector3d tarVec = new Vector3d();
					targetT3d.get(tarVec);
								
					targetT3d.mul(tmpT3d);
								
					targetT3d.get(tarVec);
								
					//ꤷ֤Ǽ
					oldtmpT3d = targetT3d;
					return targetT3d;
				}
		}
	}
		
	class ObjInfo
	{
		TransformGroup TG = new TransformGroup();
		int who;	//԰ټԤïǤ뤫Ǽ
		int talk;	// off/on:speak/on:hear
		int heart;	// ON/OFF
		int action;	// off/onŻư/onʰưư
		double tSize;	//оݤζŪĹι⤵0:or̵
		double object;	//0:off 0Ū
				
		//¸ߤƤObjInfoѤ뤫ʤliveȽ̤
		//liveON/OFFϡоݷ˹ԤΤȤ
		int live; //0: 1:ͭ -1:̵
				
		//ư饫֤³ϤONˤ뤳Ȥ
		//֤ΰư̵ʤ
		int keizoku; //0:̵͡ 1:ͭ
				
		//ưư°ξ硤˰ưΥǼOFFλ0.0
		double idoukyori;
				
		/* ʸǻ */
		static final int BOY = 1;
		static final int MOTHER = 2;
				
		static final int TALK_OFF = 10;
		static final int TALK_SPEAK = 11;
		static final int TALK_HEAR = 12;
		static final int HEART_OFF = 20;
		static final int HEART_KI = 21;
		static final int HEART_DO = 22;
		static final int HEART_AI = 23;
		static final int HEART_RAKU = 24;
		static final int ACTION_OFF = 30;
		static final int ACTION_STATIC = 31;
		static final int ACTION_DYNAMIC = 32;
				
				
		ObjInfo(int x, TransformGroup objTG,
				int a, int b, int c, double d, double e)
		{
			who = x;
			TG = objTG;
			talk = a;
			heart = b;
			action = c;
			tSize = d;
			object = e;
			live = 0;
			keizoku = 0;
			idoukyori = 0.0;
		}
				
		//ưΥϻ
		ObjInfo(int x, TransformGroup objTG,
				int a, int b, int c, double d, double e, double f)
		{
			who = x;
			TG = objTG;
			talk = a;
			heart = b;
			action = c;
			tSize = d;
			object = e;
			live = 0;
			keizoku = 0;
			idoukyori = f;
		}
				
		//λоݸ䤬餫˲ư򵯤Ƥʤ
		ObjInfo()
		{
			who = 0;
			TG = null;
			talk = 0;
			heart = 0;
			action = 0;
			tSize = 0.0;
			object = 0.0;
			live = 0;
			keizoku = 0;
			idoukyori = 0.0;
		}
	}


//=========================================================
//鲼ϡǥΤˤ롥 ƥŪʬǤϤʤ
//=========================================================
	private BranchGroup createWall(double x, double y, double z,
								   double xLeng, double yLeng, double zLeng)
	{
		BranchGroup bg = new BranchGroup();
				
		Point3d vertices[] = new Point3d[8];
				
		vertices[0] = new Point3d(x,         y,         z        );//ʱɸϡ
		vertices[1] = new Point3d(x + xLeng, y        , z        );
		vertices[2] = new Point3d(x + xLeng, y + yLeng, z        );
		vertices[3] = new Point3d(x        , y + yLeng, z        );
		vertices[4] = new Point3d(x        , y,         z + zLeng);
		vertices[5] = new Point3d(x + xLeng, y        , z + zLeng);
		vertices[6] = new Point3d(x + xLeng, y + yLeng, z + zLeng);
		vertices[7] = new Point3d(x        , y + yLeng, z + zLeng);
				
		int[] indices = {2,1,0,3,
						 3,0,4,7,
						 7,4,5,6,
						 6,5,1,2,
						 3,7,6,2,
						 4,0,1,5, };
				
		Color3f cleamA = new Color3f(0.98f, 0.98f, 0.8f);
		Color3f cleamB = new Color3f(0.92f, 0.92f, 0.8f);
		Color3f cleamC = new Color3f(1.0f, 1.0f, 0.7f);
		Color3f[] colors = { cleamA, cleamB, cleamC };
				
		int[] colorIndices = { 0,0,0,0,
							   1,1,1,1,
							   0,0,0,0,
							   1,1,1,1,
							   2,2,2,2,
							   2,2,2,2, };
				
				
		IndexedQuadArray geometry = new IndexedQuadArray(vertices.length,
														 GeometryArray.COORDINATES | GeometryArray.COLOR_3, indices.length);
		geometry.setCoordinates(0, vertices);
		geometry.setCoordinateIndices(0, indices);
		geometry.setColors(0, colors);
		geometry.setColorIndices(0, colorIndices);
				
		Shape3D wall = new Shape3D(geometry);
				
		bg.addChild(wall);
				
		//bg.compile();
				
		return bg;
	}
	//ϭɤ
	private BranchGroup createRoukaWall(double x, double y, double z,
										double xLeng, double yLeng, double zLeng)
	{
		BranchGroup bg = new BranchGroup();
				
		Point3d vertices[] = new Point3d[8];
				
		vertices[0] = new Point3d(x,         y,         z        );//ʱɸϡ
		vertices[1] = new Point3d(x + xLeng, y        , z        );
		vertices[2] = new Point3d(x + xLeng, y + yLeng, z        );
		vertices[3] = new Point3d(x        , y + yLeng, z        );
		vertices[4] = new Point3d(x        , y,         z + zLeng);
		vertices[5] = new Point3d(x + xLeng, y        , z + zLeng);
		vertices[6] = new Point3d(x + xLeng, y + yLeng, z + zLeng);
		vertices[7] = new Point3d(x        , y + yLeng, z + zLeng);
				
		int[] indices = {2,1,0,3,
						 3,0,4,7,
						 7,4,5,6,
						 6,5,1,2,
						 3,7,6,2,
						 4,0,1,5, };
				
		Color3f cA = new Color3f(0.75f, 0.98f, 0.98f);
		Color3f cB = new Color3f(0.75f, 0.92f, 0.92f);
		Color3f cC = new Color3f(0.7f, 1.0f, 1.0f);
		Color3f[] colors = { cA, cB, cC };
				
		int[] colorIndices = { 0,0,0,0,
							   1,1,1,1,
							   0,0,0,0,
							   1,1,1,1,
							   2,2,2,2,
							   2,2,2,2, };
				
				
		IndexedQuadArray geometry = new IndexedQuadArray(vertices.length,
														 GeometryArray.COORDINATES | GeometryArray.COLOR_3, indices.length);
		geometry.setCoordinates(0, vertices);
		geometry.setCoordinateIndices(0, indices);
		geometry.setColors(0, colors);
		geometry.setColorIndices(0, colorIndices);
				
		Shape3D wall = new Shape3D(geometry);
				
		bg.addChild(wall);
				
		//bg.compile();
				
		return bg;
	}
		
	//
	private BranchGroup createDoor(double x, double y, double z,
								   double xLeng, double yLeng, double zLeng,
								   double hiraki)
	{
		BranchGroup bg = new BranchGroup();
				
		//ɥĤʬ
		Point3d vertices[] = new Point3d[8];
				
		vertices[0] = new Point3d(0,         0,         0        );//ʱɸϡ
		vertices[1] = new Point3d(0 + xLeng, 0        , 0        );
		vertices[2] = new Point3d(0 + xLeng, 0 + yLeng, 0        );
		vertices[3] = new Point3d(0        , 0 + yLeng, 0        );
		vertices[4] = new Point3d(0        , 0,         0 + zLeng);
		vertices[5] = new Point3d(0 + xLeng, 0        , 0 + zLeng);
		vertices[6] = new Point3d(0 + xLeng, 0 + yLeng, 0 + zLeng);
		vertices[7] = new Point3d(0        , 0 + yLeng, 0 + zLeng);
				
		int[] indices = {2,1,0,3,
						 3,0,4,7,
						 7,4,5,6,
						 6,5,1,2,
						 3,7,6,2,
						 4,0,1,5, };
				
		Color3f red = new Color3f(1.0f, 0.0f, 0.0f);
		Color3f chairo = new Color3f(0.6f, 0.5f, 0.0f);
		Color3f koiChairo = new Color3f(0.5f, 0.4f, 0.0f);
		Color3f[] colors = { red, chairo, koiChairo };
				
		int[] colorIndices = { 2,2,2,2,
							   1,1,1,1,
							   2,2,2,2,
							   1,1,1,1,
							   0,0,0,0,
							   0,0,0,0, };
				
				
		IndexedQuadArray geometry = new IndexedQuadArray(vertices.length,
														 GeometryArray.COORDINATES | GeometryArray.COLOR_3, indices.length);
		geometry.setCoordinates(0, vertices);
		geometry.setCoordinateIndices(0, indices);
		geometry.setColors(0, colors);
		geometry.setColorIndices(0, colorIndices);
				
		Shape3D door = new Shape3D(geometry);
		//ɥĤʬޤ
				
				
		//ɥμüʬʳ¦
		Point3d verticesN[] = new Point3d[16];
				
		double xN = 0.0;
		double yN = yLeng / 3.0;
		double zN = zLeng - 0.1;
		verticesN[0] = new Point3d(xN,       yN,                     zN        );//ɥΥָ
		verticesN[1] = new Point3d(xN,       yN,                     zN + 0.03 );
		verticesN[2] = new Point3d(xN,       yN + 0.03,              zN + 0.03 );
		verticesN[3] = new Point3d(xN,       yN + 0.03,              zN        );
		verticesN[4] = new Point3d(xN - 0.1, yN,                     zN        );
		verticesN[5] = new Point3d(xN - 0.1, yN,                     zN + 0.03 );
		verticesN[6] = new Point3d(xN - 0.07, yN + 0.03,             zN + 0.03 );
		verticesN[7] = new Point3d(xN - 0.07, yN + 0.03,             zN        );
		verticesN[8] = new Point3d(xN - 0.07, yN + yLeng/3.0 - 0.03, zN        );
		verticesN[9] = new Point3d(xN - 0.07, yN + yLeng/3.0 - 0.03, zN + 0.03 );
		verticesN[10] = new Point3d(xN - 0.1, yN + yLeng/3.0,        zN + 0.03 );
		verticesN[11] = new Point3d(xN - 0.1, yN + yLeng/3.0,        zN        );
		verticesN[12] = new Point3d(xN,       yN + yLeng/3.0 - 0.03, zN        );
		verticesN[13] = new Point3d(xN,       yN + yLeng/3.0 - 0.03, zN + 0.03 );
		verticesN[14] = new Point3d(xN,       yN + yLeng/3.0,        zN + 0.03 );
		verticesN[15] = new Point3d(xN,       yN + yLeng/3.0,        zN        );
				
		int[] indicesN = { 2,1,0,3,
						   7,6,2,3,
						   6,5,1,2,
						   5,4,0,1,
						   4,7,3,0,
								
						   11,4,5,10,
						   10,5,6,9,
						   9,6,7,8,
						   8,7,4,11,
								
						   14,13,12,15,
						   11,10,14,15,
						   10,9,13,14,
						   9,8,12,13,
						   8,11,15,12, };
								
		Color3f white = new Color3f(1.0f, 1.0f, 1.0f);
		Color3f white1 = new Color3f(0.9f, 0.9f, 0.9f);
		Color3f white2 = new Color3f(0.8f, 0.8f, 0.8f);
		Color3f[] colorsN = { white, white1, white2 };
				
		int[] colorIndicesN = { 0,0,0,0,
								2,2,2,2,
								1,1,1,1,
								2,2,2,2,
								1,1,1,1,
									
								0,0,0,0,
								1,1,1,1,
								2,2,2,2,
								1,1,1,1,
									
								0,0,0,0,
								2,2,2,2,
								1,1,1,1,
								2,2,2,2,
								1,1,1,1, };
				
				
		IndexedQuadArray geometryN = new IndexedQuadArray(verticesN.length,
														  GeometryArray.COORDINATES | GeometryArray.COLOR_3, indicesN.length);
		geometryN.setCoordinates(0, verticesN);
		geometryN.setCoordinateIndices(0, indicesN);
		geometryN.setColors(0, colorsN);
		geometryN.setColorIndices(0, colorIndicesN);
                                
		Shape3D nob = new Shape3D(geometryN);
		//ɥμüʬޤǡʳ¦
                                
		//ɥμüʬ¦
		Point3d verticesN2[] = new Point3d[16];
				
		double xN2 = xLeng;
		double yN2 = yLeng / 3.0;
		double zN2 = zLeng - 0.1;
		verticesN2[0] = new Point3d(xN2,       yN2,                     zN2        );//ɥΥָ
		verticesN2[1] = new Point3d(xN2,       yN2,                     zN2 + 0.03 );
		verticesN2[2] = new Point3d(xN2,       yN2 + 0.03,              zN2 + 0.03 );
		verticesN2[3] = new Point3d(xN2,       yN2 + 0.03,              zN2        );
		verticesN2[4] = new Point3d(xN2 + 0.1, yN2,                     zN2        );
		verticesN2[5] = new Point3d(xN2 + 0.1, yN2,                     zN2 + 0.03 );
		verticesN2[6] = new Point3d(xN2 + 0.07, yN2 + 0.03,             zN2 + 0.03 );
		verticesN2[7] = new Point3d(xN2 + 0.07, yN2 + 0.03,             zN2        );
		verticesN2[8] = new Point3d(xN2 + 0.07, yN2 + yLeng/3.0 - 0.03, zN2        );
		verticesN2[9] = new Point3d(xN2 + 0.07, yN2 + yLeng/3.0 - 0.03, zN2 + 0.03 );
		verticesN2[10] = new Point3d(xN2 + 0.1, yN2 + yLeng/3.0,        zN2 + 0.03 );
		verticesN2[11] = new Point3d(xN2 + 0.1, yN2 + yLeng/3.0,        zN2        );
		verticesN2[12] = new Point3d(xN2,       yN2 + yLeng/3.0 - 0.03, zN2        );
		verticesN2[13] = new Point3d(xN2,       yN2 + yLeng/3.0 - 0.03, zN2 + 0.03 );
		verticesN2[14] = new Point3d(xN2,       yN2 + yLeng/3.0,        zN2 + 0.03 );
		verticesN2[15] = new Point3d(xN2,       yN2 + yLeng/3.0,        zN2        );
				
		int[] indicesN2 = {3,0,1,2,
						   3,2,6,7,
						   2,1,5,6,
						   1,0,4,5,
						   0,3,7,4,
								
						   10,5,4,11,
						   9,6,5,10,
						   8,7,6,9,
						   11,4,7,8,
								
						   15,12,13,14,
						   15,14,10,11,
						   14,13,9,10,
						   13,12,8,9,
						   12,15,11,8, };
				
		Color3f[] colorsN2 = { white, white1, white2 };
				
		int[] colorIndicesN2 = { 0,0,0,0,
								 2,2,2,2,
								 1,1,1,1,
								 2,2,2,2,
								 1,1,1,1,
									
								 0,0,0,0,
								 1,1,1,1,
								 2,2,2,2,
								 1,1,1,1,
									
								 0,0,0,0,
								 2,2,2,2,
								 1,1,1,1,
								 2,2,2,2,
								 1,1,1,1, };
				
				
		IndexedQuadArray geometryN2 = new IndexedQuadArray(verticesN2.length,
														   GeometryArray.COORDINATES | GeometryArray.COLOR_3, indicesN2.length);
		geometryN2.setCoordinates(0, verticesN2);
		geometryN2.setCoordinateIndices(0, indicesN2);
		geometryN2.setColors(0, colorsN2);
		geometryN2.setColorIndices(0, colorIndicesN2);
                                
		Shape3D nob2 = new Shape3D(geometryN2);
		//ɥμüʬޤǡ¦
                                
                                
		Transform3D rotation = new Transform3D();
		rotation.setRotation(new AxisAngle4d(0.0, 1.0, 0.0, -hiraki));

		TransformGroup tr2 = new TransformGroup(rotation);
		tr2.addChild(door); //ɥʬ
		tr2.addChild(nob);  //ɥΥ֡곰¦
		tr2.addChild(nob2); //ɥΥ֡¦
				
		Transform3D idou = new Transform3D();
		idou.setTranslation(new Vector3d(x, y, z));
				
				
		return bg;
	}
		
	//ơ֥
	private BranchGroup createTable(double x, double y, double z,
									double xLeng, double yLeng, double zLeng)
	{
		BranchGroup bg = new BranchGroup();
				
		Point3d vertices[] = new Point3d[40];
				
		vertices[0] = new Point3d(0,         0,         0        );//ʱɸϡ
		vertices[1] = new Point3d(0 + xLeng, 0        , 0        );
		vertices[2] = new Point3d(0 + xLeng, 0 + yLeng, 0        );
		vertices[3] = new Point3d(0        , 0 + yLeng, 0        );
		vertices[4] = new Point3d(0        , 0,         0 + zLeng);
		vertices[5] = new Point3d(0 + xLeng, 0        , 0 + zLeng);
		vertices[6] = new Point3d(0 + xLeng, 0 + yLeng, 0 + zLeng);
		vertices[7] = new Point3d(0        , 0 + yLeng, 0 + zLeng);
				
		double r = 0.05;//ơ֥εӤ
				
		//Ӥ
		for (int i=0; i<4; i++) 
			{
				int legs = i + 1;
				double a,b,c;
				if (legs == 1 || legs == 2)
					{
						a = 0.3;
					}
				else 
					{
						a = xLeng - xLeng/8.0 - r;
					}
				b = -y;
				if (legs == 1 || legs == 3)
					{
						c = 0.2;
					}
				else
					{
						c = zLeng - zLeng/8.0 - r;
					}
				vertices[8*legs]   = new Point3d(a,     b, c    );//ʱɸ)
				vertices[8*legs+1] = new Point3d(a + r, b, c    );
				vertices[8*legs+2] = new Point3d(a + r, 0, c    );
				vertices[8*legs+3] = new Point3d(a    , 0, c    );
				vertices[8*legs+4] = new Point3d(a    , b, c + r);
				vertices[8*legs+5] = new Point3d(a + r, b, c + r);
				vertices[8*legs+6] = new Point3d(a + r, 0, c + r);
				vertices[8*legs+7] = new Point3d(a    , 0, c + r);
			}
				
		int[] indices = {2,1,0,3,
						 3,0,4,7,
						 7,4,5,6,
						 6,5,1,2,
						 3,7,6,2,
						 4,0,1,5,
								
						 10,9,8,11,
						 11,8,12,15,
						 15,12,13,14,
						 14,13,9,10,
						 11,15,14,10,
						 12,8,9,13,
								
						 18,17,16,19,
						 19,16,20,23,
						 23,20,21,22,
						 22,21,17,18,
						 19,23,22,18,
						 20,16,17,21,
								
						 26,25,24,27,
						 27,24,28,31,
						 31,28,29,30,
						 30,29,25,26,
						 27,31,30,26,
						 28,24,25,29,
								
						 34,33,32,35,
						 35,32,36,39,
						 39,36,37,38,
						 38,37,33,34,
						 35,39,38,34,
						 36,32,33,37, };
				
		Color3f usuChairo = new Color3f(0.7f, 0.6f, 0.0f);
		Color3f chairo = new Color3f(0.6f, 0.5f, 0.0f);
		Color3f koiChairo = new Color3f(0.5f, 0.4f, 0.0f);
		Color3f[] colors = { usuChairo, chairo, koiChairo };
				
		int[] colorIndices = { 2,2,2,2,
							   1,1,1,1,
							   2,2,2,2,
							   1,1,1,1,
							   0,0,0,0,
							   0,0,0,0,
									
							   2,2,2,2,
							   1,1,1,1,
							   2,2,2,2,
							   1,1,1,1,
							   0,0,0,0,
							   0,0,0,0,
									
							   2,2,2,2,
							   1,1,1,1,
							   2,2,2,2,
							   1,1,1,1,
							   0,0,0,0,
							   0,0,0,0,
									
							   2,2,2,2,
							   1,1,1,1,
							   2,2,2,2,
							   1,1,1,1,
							   0,0,0,0,
							   0,0,0,0,
									
							   2,2,2,2,
							   1,1,1,1,
							   2,2,2,2,
							   1,1,1,1,
							   0,0,0,0,
							   0,0,0,0, };
				
		IndexedQuadArray geometry = new IndexedQuadArray(vertices.length,
														 GeometryArray.COORDINATES | GeometryArray.COLOR_3, indices.length);
		geometry.setCoordinates(0, vertices);
		geometry.setCoordinateIndices(0, indices);
		geometry.setColors(0, colors);
		geometry.setColorIndices(0, colorIndices);
				
		Shape3D table = new Shape3D(geometry);
				
		Transform3D idou = new Transform3D();
		idou.setTranslation(new Vector3d(x, y, z));
				
		TransformGroup tr = new TransformGroup(idou);
		tr.addChild(table);
				
				
		bg.addChild(tr);
				
		//bg.compile();
				
		return bg;
	}
		
	//¢ˤ
	private BranchGroup createFreez(double x, double y, double z,
									double xLeng, double yLeng, double zLeng)
	{
		BranchGroup bg = new BranchGroup();
				
		Point3d vertices[] = new Point3d[16];
		double t = 0.05;
				
		vertices[0] = new Point3d(0,         0,         0        );//ʱɸϡ
		vertices[1] = new Point3d(0 + xLeng, 0        , 0        );
		vertices[2] = new Point3d(0 + xLeng, 0 + yLeng, 0        );
		vertices[3] = new Point3d(0        , 0 + yLeng, 0        );
		vertices[4] = new Point3d(0        , 0,         0 + zLeng);
		vertices[5] = new Point3d(0 + xLeng, 0        , 0 + zLeng);
		vertices[6] = new Point3d(0 + xLeng, 0 + yLeng, 0 + zLeng);
		vertices[7] = new Point3d(0        , 0 + yLeng, 0 + zLeng);
		//¢ˤ¦
		vertices[8] = new Point3d(t,           t,          0        );
		vertices[9] = new Point3d(-t + xLeng,  t,          0        );
		vertices[10] = new Point3d(-t + xLeng, -t + yLeng, 0        );
		vertices[11] = new Point3d(t,          -t + yLeng, 0        );
		vertices[12] = new Point3d(t,          t,         -t + zLeng);
		vertices[13] = new Point3d(-t + xLeng, t,         -t + zLeng);
		vertices[14] = new Point3d(-t + xLeng, -t + yLeng, -t + zLeng);
		vertices[15] = new Point3d(0,          -t + yLeng, -t + zLeng);
				
		int[] indices = {3,0,4,7,
						 7,4,5,6,
						 6,5,1,2,
						 3,7,6,2,
						 4,0,1,5,
								
						 2,1,9,10,
						 9,1,0,8,
						 11,8,0,3,
						 2,10,11,3,
								
						 14,13,12,15,
						 10,9,13,14,
						 15,12,8,11,
						 10,14,15,11,
						 13,9,8,12, };
				
		Color3f coolA = new Color3f(1.0f, 1.0f, 1.0f);
		Color3f coolAB = new Color3f(0.95f, 0.95f, 0.95f);
		Color3f coolB = new Color3f(0.9f, 0.9f, 0.9f);
		Color3f coolC = new Color3f(0.85f, 0.85f, 0.85f);
		Color3f coolD = new Color3f(0.8f, 0.8f, 0.8f);
		Color3f coolE = new Color3f(0.75f, 0.75f, 0.75f);
		Color3f[] colors = { coolA, coolAB, coolB, coolC, coolD, coolE };
				
		int[] colorIndices = { 0,0,0,0,
							   1,1,1,1,
							   0,0,0,0,
							   2,2,2,2,
							   2,2,2,2,
									
							   1,1,1,1,
							   1,1,1,1,
							   1,1,1,1,
							   1,1,1,1,
									
							   3,3,3,3,
							   4,4,4,4,
							   4,4,4,4,
							   5,5,5,5,
							   5,5,5,5, };
				
		IndexedQuadArray geometry = new IndexedQuadArray(vertices.length,
														 GeometryArray.COORDINATES | GeometryArray.COLOR_3, indices.length);
		geometry.setCoordinates(0, vertices);
		geometry.setCoordinateIndices(0, indices);
		geometry.setColors(0, colors);
		geometry.setColorIndices(0, colorIndices);
				
		Shape3D freez = new Shape3D(geometry);
				
		Transform3D idou = new Transform3D();
		idou.setTranslation(new Vector3d(x, y, z));
				
		TransformGroup tr = new TransformGroup(idou);
		tr.addChild(freez);
				
				
		bg.addChild(tr);
				
		//bg.compile();
				
		return bg;
	}

	//¢ˤ
	private BranchGroup createFreezDoor(double x, double y, double z,
										double xLeng, double yLeng, double zLeng,double hiraki)
	{
		BranchGroup bg = new BranchGroup();
				
		Point3d vertices[] = new Point3d[8];
				
		vertices[0] = new Point3d(0,         0,         0        );//ʱɸϡ
		vertices[1] = new Point3d(0 + xLeng, 0        , 0        );
		vertices[2] = new Point3d(0 + xLeng, 0 + yLeng, 0        );
		vertices[3] = new Point3d(0        , 0 + yLeng, 0        );
		vertices[4] = new Point3d(0        , 0,         0 + zLeng);
		vertices[5] = new Point3d(0 + xLeng, 0        , 0 + zLeng);
		vertices[6] = new Point3d(0 + xLeng, 0 + yLeng, 0 + zLeng);
		vertices[7] = new Point3d(0        , 0 + yLeng, 0 + zLeng);
				
		int[] indices = {2,1,0,3,
						 3,0,4,7,
						 7,4,5,6,
						 6,5,1,2,
						 3,7,6,2,
						 4,0,1,5, };
				
		Color3f coolA = new Color3f(0.98f, 0.98f, 0.98f);
		Color3f coolAB = new Color3f(0.95f, 0.95f, 0.95f);
		Color3f coolB = new Color3f(0.9f, 0.9f, 0.9f);
		Color3f coolC = new Color3f(0.85f, 0.85f, 0.85f);
		Color3f coolD = new Color3f(0.8f, 0.8f, 0.8f);
		Color3f coolE = new Color3f(0.75f, 0.75f, 0.75f);
		Color3f[] colors = { coolA, coolAB, coolB, coolC, coolD, coolE };
				
		int[] colorIndices = { 0,0,0,0,
							   2,2,2,2,
							   1,1,1,1,
							   2,2,2,2,
							   5,5,5,5,
							   5,5,5,5, };
				
				
		IndexedQuadArray geometry = new IndexedQuadArray(vertices.length,
														 GeometryArray.COORDINATES | GeometryArray.COLOR_3, indices.length);
		geometry.setCoordinates(0, vertices);
		geometry.setCoordinateIndices(0, indices);
		geometry.setColors(0, colors);
		geometry.setColorIndices(0, colorIndices);
				
		Shape3D door = new Shape3D(geometry);
				
		Transform3D rotation = new Transform3D();
		rotation.setRotation(new AxisAngle4d(0.0, 1.0, 0.0, hiraki));
				
		TransformGroup tr2 = new TransformGroup(rotation);
		tr2.addChild(door);
				
		Transform3D idou = new Transform3D();
		idou.setTranslation(new Vector3d(x, y, z));
				
		TransformGroup tr1 = new TransformGroup(idou);
		tr1.addChild(tr2);
				
				
		bg.addChild(tr1);
				
		//bg.compile();
				
		return bg;
	}
		
	/*
	//ȤꤢλоݤǤΤ
	private BranchGroup createSphere(double x, double y, double z, float r)
	{
		BranchGroup bg = new BranchGroup();
				
		Sphere sphere = new Sphere(r);
				
		Transform3D idou = new Transform3D();
		idou.setTranslation(new Vector3d(x, y, z));
				
		SphereTG.setTransform(idou);
		SphereTG.addChild(sphere);
				
		//Υȥ󥹥եμ
		SphereTG.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		SphereTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
				
		bg.addChild(SphereTG);
				
		//bg.compile();
				
		return bg;
	}
	*/

	//ȤƱ
	private BranchGroup createCylinder(double x, double y, double z,
									   float r, float h, float red, float green, float blue)
	{
		BranchGroup bg = new BranchGroup();

		Cylinder cylinder = new Cylinder(r, h);

		Transform3D idou = new Transform3D();
		idou.setTranslation(new Vector3d(x, y + h/2.0, z));


		//
		Material mat = new Material();
		mat.setDiffuseColor(new Color3f(red, green, blue));
		mat.setAmbientColor(new Color3f(red*0.7f, green*0.7f, blue*0.7f));
		Appearance ap = new Appearance();
		ap.setMaterial(mat);
		cylinder.setAppearance(ap);
				
		//ư
		TransformGroup cylinderTG = new TransformGroup();
		cylinderTG.setTransform(idou);
		cylinderTG.addChild(cylinder);
				
				
		bg.addChild(cylinderTG);
				
		return bg;
	}
		
	//ȤΩΤ
	private BranchGroup createBox(double x, double y, double z,
								  float xdim, float ydim, float zdim,
								  float red, float green, float blue)
	{
		BranchGroup bg = new BranchGroup();
				
		//
		Material mat = new Material();
		mat.setDiffuseColor(new Color3f(red, green, blue));
		mat.setAmbientColor(new Color3f(red/2.0f, green/2.0f, blue/2.0f));
		Appearance ap = new Appearance();
		ap.setMaterial(mat);
				
		Box box = new Box(xdim, ydim, zdim, ap);
		Transform3D idou = new Transform3D();
		idou.setTranslation(new Vector3d(x, y + ydim, z));
				
		//ư
		TransformGroup boxTG = new TransformGroup();
		boxTG.setTransform(idou);
		boxTG.addChild(box);
				
				
		bg.addChild(boxTG);
				
		return bg;
	}
		
	//κ
	private BranchGroup createSky()
	{
		BranchGroup bg = new BranchGroup();
				
		Point3d vertices[] = new Point3d[8];
				
		vertices[0] = new Point3d(-100, 50, -100);//ʱɸϡ
		vertices[1] = new Point3d(-100, 50, 100);
		vertices[2] = new Point3d(100, 50, 100);
		vertices[3] = new Point3d(100, 50, -100);
		vertices[4] = new Point3d(-100, -50, -100);
		vertices[5] = new Point3d(100, -50, -100);
		vertices[6] = new Point3d(-100, -50, 100);
		vertices[7] = new Point3d(100, -50, 100);
				
				
		int[] indices = { 3,2,1,0,
						  0,4,5,3,
						  1,6,4,0,
						  1,2,7,6,
						  3,5,7,2 };
				
		Color3f Sky = new Color3f(0.2f, 0.2f, 0.2f);
		Color3f[] colors = { Sky };
				
		int[] colorIndices = { 0,0,0,0,
							   0,0,0,0,
							   0,0,0,0,
							   0,0,0,0,
							   0,0,0,0 };
				
				
		IndexedQuadArray geometry = new IndexedQuadArray(vertices.length,
														 GeometryArray.COORDINATES | GeometryArray.COLOR_3, indices.length);
		geometry.setCoordinates(0, vertices);
		geometry.setCoordinateIndices(0, indices);
		geometry.setColors(0, colors);
		geometry.setColorIndices(0, colorIndices);
				
		Shape3D sky = new Shape3D(geometry);

		bg.addChild(sky);
				
		//bg.compile();
				
		return bg;
	}
		
	//ŷκ
	private BranchGroup createTenjo()
	{
		BranchGroup bg = new BranchGroup();
				
		Point3d vertices[] = new Point3d[4];
				
		vertices[0] = new Point3d(0, 3, 0);//ʱɸϡ
		vertices[1] = new Point3d(0, 3, 7.1);
		vertices[2] = new Point3d(7.2, 3, 7.1);
		vertices[3] = new Point3d(7.2, 3, 0);
				
		vertices[0] = new Point3d(-2.1, 3, -2.1);//ʱɸϡ
		vertices[1] = new Point3d(-2.1, 3, 9.1);
		vertices[2] = new Point3d(7.2, 3, 9.1);
		vertices[3] = new Point3d(7.2, 3, -2.1);
				
				
		int[] indices = { 3,2,1,0 };
				
		Color3f TenjoC = new Color3f(0.95f, 0.95f, 0.8f);
		Color3f[] colors = { TenjoC };
				
		int[] colorIndices = { 0,0,0,0 };
				
				
		IndexedQuadArray geometry = new IndexedQuadArray(vertices.length,
														 GeometryArray.COORDINATES | GeometryArray.COLOR_3, indices.length);
		geometry.setCoordinates(0, vertices);
		geometry.setCoordinateIndices(0, indices);
		geometry.setColors(0, colors);
		geometry.setColorIndices(0, colorIndices);
				
		Shape3D tenjo = new Shape3D(geometry);
				
		bg.addChild(tenjo);
				
		//bg.compile();
				
		return bg;
	}
		
	//åξ
	private BranchGroup createKitchinFloor()
	{
		BranchGroup bg = new BranchGroup();
				
		int roop = 8;
				
		Point3f[] vertices = new Point3f[roop * roop];
				
		float start = 0.0f;
				
		float x = start+0.1f;
		float z = start;
				
		float step = 1.0f;
				
		int[] indices = new int[(roop - 1)*(roop - 1) * 4];
		int n = 0;
				
		Color3f yuka0 = new Color3f(0.75f, 0.9f, 1.0f);
		Color3f yuka1 = new Color3f(0.65f, 0.8f, 1.0f);
		Color3f[] colors = { yuka1, yuka0 };
				
		int[] colorindices = new int[indices.length];
				
		for (int i=0; i<roop; i++)
			{
				for (int j=0; j<roop; j++)
					{
						vertices[i*roop + j] = new Point3f(x, 0.003f, z);//1ߥ
						z += step;
						if (i<(roop - 1) && j<(roop - 1))
							{
								int cindex = (i % 2 + j) % 2;
								colorindices[n] = cindex; indices[n++] = i       * roop + j;
								colorindices[n] = cindex; indices[n++] = i       * roop + (j + 1);
								colorindices[n] = cindex; indices[n++] = (i + 1) * roop + (j + 1);
								colorindices[n] = cindex; indices[n++] = (i + 1) * roop + j;
							}
					}
				z = start;
				x += step;
			}
				
		IndexedQuadArray geom = new IndexedQuadArray( vertices.length,
													  GeometryArray.COORDINATES |
													  GeometryArray.COLOR_3,
													  indices.length );
		geom.setCoordinates(0, vertices);
		geom.setCoordinateIndices(0, indices);
		geom.setColors(0, colors);
		geom.setColorIndices(0, colorindices);
				
		Shape3D floor = new Shape3D(geom);
		floor.setCollidable(false);        // ͤΤʤ褦ˤ
		bg.addChild(floor);
				
		bg.compile();
				
		return bg;
	}
		
	// åͤξ
	private BranchGroup createFloor()
	{
		BranchGroup bg = new BranchGroup();
				
		int roop = 40;
				
		Point3f[] vertices = new Point3f[roop * roop];
				
		float start = -20.0f;
				
		float x = start;
		float z = start;
				
		float step = 1.0f;
				
		int[] indices = new int[(roop - 1)*(roop - 1) * 4];
		int n = 0;
				
		/*
		  white = new Color3f(1.0f, 1.0f, 1.0f);
		  black = new Color3f(0.0f, 0.0f, 0.0f);
		  colors = { white, black };
		*/
				
		Color3f yuka0 = new Color3f(0.9f, 0.85f, 1.0f);
		Color3f yuka1 = new Color3f(0.8f, 0.75f, 1.0f);
		Color3f[] colors = { yuka0, yuka1 };
				
		int[] colorindices = new int[indices.length];
				
		for (int i=0; i<roop; i++) {
			for (int j=0; j<roop; j++) {
				vertices[i*roop + j] = new Point3f(x, 0.0f, z);
				z += step;
				if (i<(roop - 1) && j<(roop - 1)) {
					int cindex = (i % 2 + j) % 2;
					colorindices[n] = cindex; indices[n++] = i       * roop + j;
					colorindices[n] = cindex; indices[n++] = i       * roop + (j + 1);
					colorindices[n] = cindex; indices[n++] = (i + 1) * roop + (j + 1);
					colorindices[n] = cindex; indices[n++] = (i + 1) * roop + j;
				}
			}
			z = start;
			x += step;
		}
				
		IndexedQuadArray geom = new IndexedQuadArray( vertices.length,
													  GeometryArray.COORDINATES |
													  GeometryArray.COLOR_3,
													  indices.length );
		geom.setCoordinates(0, vertices);
		geom.setCoordinateIndices(0, indices);
		geom.setColors(0, colors);
		geom.setColorIndices(0, colorindices);
				
		Shape3D floor = new Shape3D(geom);
		floor.setCollidable(false);        // ͤΤʤ褦ˤ
		bg.addChild(floor);

		bg.compile();
				
		return bg;
	}
}


