package Stage3D;
import DataPack.*;

public class ActInterrupt extends Acting
{
	private Actor target;
	private String actingname;
	private int signal;
	private int qnum;
	private int mode;
	public boolean setOption(DataPack[] datapacks)
	{
		setIsActive(false);
		if(datapacks.length<1) return false;
		DataPack datapack = datapacks[0];
		int[] id = datapack.getIntData();
		double[] dd = datapack.getDoubleData();
		String[] sd = datapack.getStringData();

		if (id.length<1)
			return false;
		if (id[0]==0)
		{
			if (id.length < 2)
				return false;
			if (sd.length < 2)
				return false;

			target = getStage().getActor(sd[0]);
			if (target==null) return false;
			actingname=sd[1];
			signal = id[1];
			mode = 0;
		} else if(id[0]==1)
		{
			if (id.length < 3)
				return false;
			if (sd.length < 1)
				return false;

			target = getStage().getActor(sd[0]);
			if (target==null) return false;
			qnum=id[1];
			signal = id[2];
			mode = 1;
		} else {
			return false;
		}


		setIsActive(true);
		return true;
	}

	public boolean doActing()
	{	
		Acting acting;
		if (mode==0)
			acting = target.getActingInQueue(actingname);
		else
			acting = target.getActingInQueue(qnum);			
	
		if (acting==null) return false;
		acting.setInterruptedFlag(signal);
		//target.setInterruptedFlag(signal);
		setIsActive(false);
		return false;
	}
}
