package Stage3D;
import DataPack.*;
import javax.vecmath.*;


public class ActTurn extends Acting
{
	private Actor target;
	private Vector3d point;
	private Vector3d dir;
	private Vector3d r = new Vector3d();
	private double Speed;
	private boolean lock;
	private boolean latiFlag,longFlag;
	private int mode;
	public boolean setOption(DataPack[] datapacks)
	{
		double x,y,z,s;
		setIsActive(false);
		//if(datapacks.length<1) return false;
		DataPack datapack = datapacks[0];
		int[] id = datapack.getIntData();
		double[] dd = datapack.getDoubleData();
		String[] sd = datapack.getStringData();
		if (id.length < 1)
			return false;
		if (id[0]==0)
		{
			if (id.length < 2)
				return false;
			if (sd.length < 1)
				return false;
			if (dd.length < 1)
				return false;

			target=getStage().getActor(sd[0]);
			if (target==null) return false;
			s = dd[0];
			Speed = 2*Math.PI*s*((double)(getStage().getClockTime())/1000d);
			if (id[1]==0) lock = false;
			else lock = true;
			mode = 0;
		}else if (id[0]==1){
			if (id.length < 2)
				return false;
			if (dd.length < 4)
				return false;

			x=dd[0];
			y=dd[1];
			z=dd[2];
			point = new Vector3d(x,y,z);
			s = dd[3];
			Speed = 2*Math.PI*s*((double)(getStage().getClockTime())/1000d);
			if (id[1]==0) lock = false;
			else lock = true;
			mode = 1;
		}else if (id[0]==2){
			if (dd.length < 4)
				return false;

			x=dd[0];
			y=dd[1];
			z=dd[2];

			dir = new Vector3d(x,y,z);
			s = dd[3];
			Speed = 2*Math.PI*s*((double)(getStage().getClockTime())/1000d);
			lock=false;
			mode = 2;
		}else if (id[0]==3){
			if (dd.length < 3)
				return false;

			r.x=dd[0];
			r.y=dd[1];
			s = dd[2];
			Speed = 2*Math.PI*s*((double)(getStage().getClockTime())/1000d);
			lock=false;
			mode = 3;
		}else if (id[0]==4){
			if (dd.length < 2)
				return false;

			r.y=dd[0];
			s = dd[1];
			Speed = 2*Math.PI*s*((double)(getStage().getClockTime())/1000d);
			lock = false;
			mode = 4;
			latiFlag=true;
		}else if (id[0]==5){
			if (dd.length < 2)
				return false;

			r.x=dd[0];
			s = dd[1];
			Speed = 2*Math.PI*s*((double)(getStage().getClockTime())/1000d);
			lock = false;
			mode = 5;
			longFlag=true;
		}else{
			return false;
		}

		if (Math.PI < r.x)
		{
			r.x = (r.x+Math.PI)%(Math.PI*2)-Math.PI;
		}else if (r.x < -Math.PI)
		{
			r.x = (r.x-Math.PI)%(Math.PI*2)+Math.PI;
		}
		if (Math.PI < r.y)
		{
			r.y = (r.y+Math.PI)%(Math.PI*2)-Math.PI;
		}else if (r.y < -Math.PI)
		{
			r.y = (r.y-Math.PI)%(Math.PI*2)+Math.PI;
		}

		setIsActive(true);
		return true;

	}

	public boolean doActing()
	{
		if (getInterruptedFlag()!=0)
		{
			setIsActive(false);
			return false;
		}
		//if (event!=null) {getStage().throwEvent(event); event = null;}
		double t;
		double radt;
		Vector3d r2;
		r2 = getTargetActor().getAngle();
		if (mode==0){
			dir = target.getPosition();
			dir.sub(getTargetActor().getPosition());
			r = getStage().getAngle(dir);
		}else if (mode==1){
			dir = new Vector3d(point);
			dir.sub(getTargetActor().getPosition());
			r = getStage().getAngle(dir);
		}else if (mode==2){
			r = getStage().getAngle(dir);
			//}else if (mode==3){
		}else if (mode==4){
			r.x=r2.x;
		}else if (mode==5){
			r.y=r2.y;
		}

		//===========================================
		//longitude
		if (!longFlag){
			radt = r2.y;
			//System.out.println("t:"+r.y+" "+radt);
			//t = (r.y - r2[1])%(2*Math.PI);	
			t = r.y - r2.y;
			if (Math.PI <= t)
			{
				t = (t+Math.PI)%(Math.PI*2)-Math.PI;
			}else if (t < -Math.PI)
			{
				t = (t-Math.PI)%(Math.PI*2)+Math.PI;
			}
			//System.out.println(t+" "+Speed);
			//夷Ȥν
			if (Math.abs(t)<=(Speed/2)){
				r2.y=r.y;
				if(!lock) longFlag=true;
			}else{
				if (t>0) radt+=Speed;
				else radt-=Speed;
				r2.y=radt;
			}
		}
		//===========================================
		//latitude
		if (!latiFlag){
			t=r.x-r2.x;
			if (Math.PI < t)
			{
				t = (t+Math.PI)%(Math.PI*2)-Math.PI;
			}else if (t < -Math.PI)
			{
				t = (t-Math.PI)%(Math.PI*2)+Math.PI;
			}
			if (Math.abs(t)<(Speed/2))
			{
				r2.x=r.x;
				if(!lock) latiFlag=true;
			}else{
				if (t>0)
					r2.x += Speed;
				else
					r2.x-=Speed;
			}
		
		}
		//===========================================
		getTargetActor().turnAngle(r2);
		if (latiFlag && longFlag) setIsActive(false);
		return true;
	}
}
