package Stage3D;
import DataPack.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.util.HashMap;
import java.util.Set;
import java.util.Iterator;
import java.util.Collection;
import java.io.*;

/**
 * Υ饹Java 3D APIΣ֤δäLocale
 * Ѿ饹Ǥ롣class ActorΥ󥹥󥹤
 * ɲä뤳Ȥǣ뤳ȤǤ롣
 * StageɬܤǤStageCameraManStageManager
 * ɤ"StageCameraMan""StageManager"ȸ̾
 * ϿƤ롣
 */
public class Stage extends Locale implements Runnable
{
	private int clocktime=100;  //δֳ֡ms
	private Thread thread;
	private HashMap actorlist = new HashMap();	//ActorȤ̾Υޥå
	private HashMap availableactor = new HashMap();//StageɲòǽActorΥꥹ
	private Actor stagemanager; //StageΥޥ͡㡼Actor
	private CameraMan stagecameraman; //StageΥޥ
	private PositionInterpolator positioninterpolator;
	private AngleInterpolator angleinterpolator;
	//ϾΥ٥ȥȤ¾äˤʤ٥ȥ뷲Ǥ
	private Vector3d upwardvec = new Vector3d();    //Ȥʤؤ٥ȥ
	private Vector3d[] basevec = new Vector3d[3]; //١ˤʤ{x',y',z'}
	private double baseangle; //Ȥʤؤ٥ȥؤβž
	private Matrix3d basematrix = new Matrix3d();  //baseangleɽMatrix3d
	private BranchGroup actorsbranchgroup = new BranchGroup();
	private boolean goflag;

    /**
     * Υ󥹥ȥ饯ϥѡ饹Ǥ
     * LocaleΥ󥹥ȥ饯ɬפǤVirtualUniverse
     * ˻ġStageManagerϤΥ󥹥ȥ饯
     * 뤬StageCameraManϥ󥹥ȥ饯θ
     * setStageCameraMan(CameraMan cameraman)᥽åɤ
     * ѤϿɬפ롣
     * μΥå100msѤ롣
     * @param vu ѡ饹ǤLocaleΥ󥹥ȥ饯
     * Ѥ
     * @see #setStageCameraMan(CameraMan cameraman) 
     */
	public Stage(VirtualUniverse vu)
	{
		super(vu);
		thread = new Thread(this);
		actorsbranchgroup.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);

		setUpwardVec(new Vector3d(0d,1d,0d));

		stagemanager = new Actor();
        stagemanager.setName("StageManager");
		addActor(stagemanager);
		this.clocktime=100;
		positioninterpolator = new PositionInterpolator(actorlist.values());
		positioninterpolator.getAlpha().setIncreasingAlphaDuration((long)(this.clocktime));
		positioninterpolator.setSchedulingBounds(new BoundingSphere());
		angleinterpolator = new AngleInterpolator(actorlist.values());
		angleinterpolator.getAlpha().setIncreasingAlphaDuration((long)(this.clocktime));
		angleinterpolator.setSchedulingBounds(new BoundingSphere());
		actorsbranchgroup.addChild(positioninterpolator);
		actorsbranchgroup.addChild(angleinterpolator);
	}

    /**
     * Υ󥹥ȥ饯ϥѡ饹Ǥ
     * LocaleΥ󥹥ȥ饯ɬפǤVirtualUniverse
     * ˻ġ
     * StageManagerϤΥ󥹥ȥ饯
     * 뤬StageCameraManϥ󥹥ȥ饯θ
     * setStageCameraMan(CameraMan cameraman) 
     * ᥽åɤѤϿɬפ롣
     * μΥå˰clocktimeѤ롣
     * @param vu ѡ饹ǤLocaleΥ󥹥ȥ饯
     * Ѥ
     * @param clocktime μΥåͤ
     * ߥñ̤ǻꤹ
     * @see #setStageCameraMan(CameraMan cameraman) 
     */
	public Stage(VirtualUniverse vu,int clocktime)
	{
		super(vu);
		thread = new Thread(this);
		actorsbranchgroup.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);

		setUpwardVec(new Vector3d(0d,1d,0d));

		stagemanager = new Actor();
        stagemanager.setName("StageManager");
		addActor(stagemanager);
		this.clocktime=clocktime;
		positioninterpolator = new PositionInterpolator(actorlist.values());
		positioninterpolator.getAlpha().setIncreasingAlphaDuration((long)(this.clocktime));
		positioninterpolator.setSchedulingBounds(new BoundingSphere());
		angleinterpolator = new AngleInterpolator(actorlist.values());
		angleinterpolator.getAlpha().setIncreasingAlphaDuration((long)(this.clocktime));
		angleinterpolator.setSchedulingBounds(new BoundingSphere());
		actorsbranchgroup.addChild(positioninterpolator);
		actorsbranchgroup.addChild(angleinterpolator);
	}

//==================================================
//ѥåѤΥ᥽å
//==================================================
	Matrix3d getBaseMatrix(){return basematrix;}
	//latitudelongitude餽бžѤMatrix3d
	Matrix3d getRotation(Vector3d vec)
	{
		Matrix3d rt = new Matrix3d();
		Matrix3d ms = new Matrix3d();
		Matrix3d rv = new Matrix3d();
		
		rt.set(new AxisAngle4d(basevec[2],vec.y-(Math.PI/2)));	
		ms.set(new AxisAngle4d(basevec[0],Math.PI-vec.x));
		//rt.set(new AxisAngle4d(basevec[2],longitude));	
		//ms.set(new AxisAngle4d(basevec[1],latitude));
		rv.set(basematrix);
		rt.mul(ms);
		rt.mul(rv);
		return rt;
	}
//================================================
//֥饹¹Ԥ٤ޥ
//================================================
//================================================
//¹Ԥ륳ޥ
//================================================	
//================================================
//Stage
	/**
     * actor򤳤StageϿ롣Υ᥽åɤθ
     * setVisible(Actor actor, boolean v)᥽åɤǲĻˤʤ
     * ԲĻΤޤޤǤ롣
     * @param actor StageϿActor
     * @see #setVisible(Actor actor, boolean v)
     */
	public void addActor(Actor actor)
	{
		actorlist.put(actor.getName(),actor);
		actor.setStage(this);
		//		addBranchGraph(actor);
		actor.joinStage(this);
	}
    /**
     * SceneϿƤactorϿ롣
     * @param actor ϿActor
     */
	public void removeActor(Actor actor)
	{
		setVisible(actor,false);
		actorlist.remove(actor.getName());
	}
	/**
     * StageCameraManΥ᥽åcatchEvent(DataPack arg)
     * ƤӽФ
     * @param datapack ȤϤDataPack
     */
	public void throwEvent(DataPack datapack)
	{
		if (stagecameraman==null)System.out.println("There is not StageCameraMan:" + datapack.toString());
		stagecameraman.catchEvent(datapack);
	}
	/**
     * actorname餽̾Actor롣
     * ¸ߤʤnull֤
     * @param actorname 
     */
	public Actor getActor(String actorname)	
	{
		Actor tmp;

		tmp = (Actor)(actorlist.get(actorname));
		if ( tmp==null ) System.out.println("no such Actor:"+actorname);
		return tmp;
	}
	/**
     * StageϿƤActorCollection֤
     */
	public Collection getActors()
	{
		return actorlist.values();
	}
    /**
     * StageManager˥ޥɤ¹Ԥ롣
     * @param datapack ¹Ԥ륳ޥɤɽDataPack
     */
    public void execCommand(DataPack datapack)
	{
		stagemanager.interpret(datapack);
	}
	/**
     * ActorTypeNameꤷActorΥ󥹥󥹤
     * @param actortype setActorType᥽åɤˤäActorΥ饹
     * ̾ϢŤƻѲǽActorTypeȤϿ롣
     * @param actorname Actorꤹ̾
     * @return ActorΥ󥹥󥹤֤
     * ꤵ줿actortypeStage˻ѲǽActorType
     * ȤϿƤʤnull֤
     */
	public Actor getNewActor(String actortype,String actorname)
	{
		Class tmp = (Class)(availableactor.get(actortype));
		//System.out.println(actingname + " " +AvailableActing);
		//System.out.println(tmp);
		if (tmp == null)
		{
			System.out.println("no such Actor type:" + actortype);
			return null;
		}
		Actor newactor;
		try
		{
			newactor = (Actor)tmp.newInstance();
		}catch(Exception e){
			System.out.println(e);
			return null;
		}
		newactor.setName(actorname);
		newactor.setStage(this);
		return newactor;
	}
	/**
     * ActorTypeNameꤷActorΥ󥹥󥹤
     * @param datapack datapackgetStringData()ˤäƼ
     * stringǤActorTypeȤơǤ
     * Actor̾Ȥư
     * @return ActorΥ󥹥󥹤֤
     * ꤵ줿actortypeStage˻ѲǽActorType
     * ȤϿƤʤnull֤
     * ޤdatapacktringnull⤷
     * Ĺ1ʲλnull֤롣
     */
	public Actor getNewActor(DataPack datapack)
	{
		String[] sd = datapack.getStringData();
		if (sd.length<2)
			return null;
		String actortype = sd[0];
		String actorname = sd[1];
		Class tmp = (Class)(availableactor.get(actortype));
		//System.out.println(actingname + " " +AvailableActing);
		//System.out.println(tmp);
		if (tmp == null)
		{
			System.out.println("no such Actor type:" + actortype);
			return null;
		}
		Actor newactor;
		try
		{
			newactor = (Actor)tmp.newInstance();
		}catch(Exception e){
			System.out.println(e);
			return null;
		}
		newactor.setName(actorname);
		newactor.setStage(this);
		DataPack[] dpd = datapack.getDataPack();
		if (dpd.length>0)
		{
			for (int i=0;i<dpd.length;i++)
			{
				newactor.interpret(dpd[i]);
			}
		}
		return newactor;
	}
	/**
     * Actorɽɽˤ롣
     * ǸɽVirtualUniverse
     * ΡɤȤ¸ߤƤ뤫ƤʤǤ롣
     * @param actor оݤȤʤactor
     * @param v trueɽfalseɽˤ롣
     */
	public void setVisible(Actor actor,boolean v)
    {
		if (v)
		{
			try
			{	
				actorsbranchgroup.addChild(actor.getBranchGroup());
				//addBranchGraph(actor.getBranchGroup());
			}catch(MultipleParentException e)
			{}
		}else{
			try
			{
				//removeBranchGraph(actor.getBranchGroup());
				removeBranchGraph(actor.getBranchGroup());
			}catch(CapabilityNotSetException e)
			{}
		}
	}
	/**
     * ActorΥ饹ѲǽActorTypeˤȤ
     * actortypeactortypename̾ϢդStageϿ롣
     * @param actortypename actortype˴ϢŤ̾
     * @param actortype ѲǽActorTypeȤϿ
     * ActorѾ饹
     */
	public void setActorType(String actortypename,Class actortype)
	{
		if(!Actor.class.isAssignableFrom(actortype))
		{
			System.out.println("Error:Class"+actortype.toString()+
							   "is not super class of Actor");
			return;
		}
		availableactor.put(actortypename,actortype);
	}
	/**
     * ơޥ͡ǤActor롣
     * @return StageΥơޥ͡ǤActor
     */
	public Actor getStageManager(){ return stagemanager; }

	/**
     * ޥǤCameraMan롣
     * @return StageΥޥǤCameraMan
     */
	public CameraMan getStageCameraMan(){ return stagecameraman; }

	/**
     * δֳ֤
     * @return δֳ
     */
	public int getClockTime(){ return clocktime; }

    /**
     * addActor᥽åɤˤäɲä줿
     * setVisible᥽åɤˤäƲĻˤ줿Actor
     * BranchGroupΡɤȤɲäƤ
     * BranchGroup롣
     * @return Ļꤵ줿ActorΥΡɤɲäƤ
     * BranchGroup
     */
	public BranchGroup getActorsBranchGroup()
	{
		return actorsbranchgroup;
	}
	/**
     * StageΥơޥꤹ롣
     * @param cameraman оݤȤʤ륫ޥ
     */
	public void setStageCameraMan(CameraMan cameraman)
	{
		//˥餬¸ߤƤк
		if(stagecameraman!=null)
		{
			removeActor(stagecameraman);
		}
		
		cameraman.setName("StageCameraMan");
		stagecameraman = cameraman;
		addActor(cameraman);
		setVisible(cameraman,true);
	}
//================================================
//٥ȥ
    /**
     * Stageˤɽ٥ȥ롣
     * Υ٥ȥsetUpwardVec᥽åɤˤäꤵ롣
     * ɸǤ(0,1,0)ѤƤ롣
     * @return ֤ˤƾɽ٥ȥ롣
     * @see #setUpwardVec(Vector3d Upwardvec) setUpwardVec(Vector3d Upwardvec)
     */ 
	public Vector3d getUpwardVec()
	{
		return upwardvec;
	}
	/**
     * Stageλ֤ˤɽ٥ȥ
     * ꤹ롣ɸǤ(0,1,0)ѤƤ롣
     * @param upwardvec Stageꤹɽ٥ȥ롣
     * @see #getUpwardVec() getUpwardVec()
     */
	public void setUpwardVec(Vector3d upwardvec)
	{
		Vector3d cross = new Vector3d();
		double angle;
		this.upwardvec.set(upwardvec);
		this.upwardvec.normalize();
		basevec[0]=new Vector3d(1d,0d,0d);
		basevec[1]=new Vector3d(0d,1d,0d);
		basevec[2]=new Vector3d(0d,0d,1d);
		cross.cross(basevec[2],this.upwardvec);
		baseangle = this.upwardvec.angle(basevec[2]);
		basematrix.set(new AxisAngle4d(cross,baseangle));
		basematrix.transform(basevec[0]);
		basematrix.transform(basevec[1]);
		basematrix.transform(basevec[2]);
		//System.out.println(basevec[0]);
		//System.out.println(basevec[1]);
		//System.out.println(basevec[2]);

	}
	/**
     * upwardvecȤơMatrix3d mɽž
     * ٤ɽVector3dˤ֤
     * @param m ٤᤿Matrix3d
     * @return mζ˺ɸɽ
     */
	public Vector3d getAngle(Matrix3d m)
	{
		Vector3d vec = new Vector3d(0d,0d,-1d);
		//System.out.println("gA"+m+"\n"+vec);
		m.transform(vec);
		//System.out.println("gA"+m+"\n"+vec);
		return getAngle(vec);
	}
    /**
     * vec٥ȥȤƤγ٤롣
     * @param vec ٤᤿Vector3d
     * @return vecγ١
     */
	public Vector3d getAngle(Vector3d vec)
	{
		double[] r = new double[2];   //r[0]:latitude,r[1]:longitude
		double t;
		r[0]=vec.angle(basevec[2]);   //Ȥμ
		Vector3d vecXY = new Vector3d();
		Vector3d vecA = new Vector3d();
		t = vec.dot(basevec[2]);
		vecXY.scaleAdd(-t,basevec[2],vec); //vecXYʬ
		r[1] = basevec[0].angle(vecXY);
		vecA.cross(basevec[0],vecXY);
		if (vecA.dot(basevec[2])<0) r[1]=-r[1];//դμ
		//System.out.println("gA:"+r[0]+" "+r[1]);

		//		r[0] = Math.PI-r[0];
		//r[1] = Math.PI - r[1];
		return new Vector3d(r[0],r[1],0d);

	}

//================================================
//åɽ
    /**
     * Stageư򳫻Ϥ롣
     */
	public void start()
	{
		addBranchGraph(actorsbranchgroup);
		goflag=true;
		thread.start(); 
	}
    /**
     * Stage˴Ǥ֤ˤ롣
     */
	public void dispose()
	{
		goflag=false;
	}
	public void run()
	{
		Iterator list;
		Actor tmp;
		Object tmpt;

		while (goflag)
		{
			list = (actorlist.values()).iterator();
			while (list.hasNext())
			{
				tmp = (Actor)list.next();
				if (tmp.getPosFlag() == 3)
					tmp.setPosFlag(0);
				if (tmp.getAngFlag() == 3)
					tmp.setAngFlag(0);
				tmp.setOldPosition(tmp.getPosition());
				tmp.setOldAngle(tmp.getAngle());
				tmp.doActing();
				if (tmp.getPosFlag() == 1)
					tmp.setPosFlag(2);
				if (tmp.getAngFlag() == 1)
					tmp.setAngFlag(2);
			}
			positioninterpolator.move(true);
			angleinterpolator.move(true);
			try{
				thread.sleep(clocktime);
			}catch(InterruptedException e)
			{}
		}
	}
}
