package Actors;
import javax.media.j3d.*;
import javax.vecmath.*;
import Stage3D.*;

public class Door extends Actor
{
	public double openAngle=0;
	public Door()
	{
		setActing("open",ActDoorOpen.class);
		getTransformGroup().addChild(createDoor(0.05, 2.0, 1.0));
	}
//=======================================================================
//ܥ᥽å
//=======================================================================
	public void setOpenAngle(double angle)
	{
		Transform3D tg = new Transform3D();
		getTransformGroup().getTransform(tg);
		tg.setRotation(new AxisAngle4d(0d,1d,0d,angle));
		getTransformGroup().setTransform(tg);
		//setDirectionY(getDirectionY()+angle);
		openAngle=angle;
	}
	public double getOpenAngle()
	{
		return openAngle;
	}

//=======================================================================
//ʲǤԤΥץ
//=======================================================================
//	private BranchGroup createDoor(double x, double y, double z,
//								   double xLeng, double yLeng, double zLeng,
//								   double hiraki)
	private BranchGroup createDoor(double xLeng, double yLeng, double zLeng)
	{
		BranchGroup bg = new BranchGroup();
		//ɥĤʬ
		Point3d vertices[] = new Point3d[8];
				
		vertices[0] = new Point3d(0,         0,         0        );//ʱɸϡ
		vertices[1] = new Point3d(0 + xLeng, 0        , 0        );
		vertices[2] = new Point3d(0 + xLeng, 0 + yLeng, 0        );
		vertices[3] = new Point3d(0        , 0 + yLeng, 0        );
		vertices[4] = new Point3d(0        , 0,         0 + zLeng);
		vertices[5] = new Point3d(0 + xLeng, 0        , 0 + zLeng);
		vertices[6] = new Point3d(0 + xLeng, 0 + yLeng, 0 + zLeng);
		vertices[7] = new Point3d(0        , 0 + yLeng, 0 + zLeng);
				
		int[] indices = {2,1,0,3,
						 3,0,4,7,
						 7,4,5,6,
						 6,5,1,2,
						 3,7,6,2,
						 4,0,1,5, };
				
		Color3f red = new Color3f(1.0f, 0.0f, 0.0f);
		Color3f chairo = new Color3f(0.6f, 0.5f, 0.0f);
		Color3f koiChairo = new Color3f(0.5f, 0.4f, 0.0f);
		Color3f[] colors = { red, chairo, koiChairo };
				
		int[] colorIndices = { 2,2,2,2,
							   1,1,1,1,
							   2,2,2,2,
							   1,1,1,1,
							   0,0,0,0,
							   0,0,0,0, };
				
				
		IndexedQuadArray geometry = new IndexedQuadArray(vertices.length,
														 GeometryArray.COORDINATES | GeometryArray.COLOR_3, indices.length);
		geometry.setCoordinates(0, vertices);
		geometry.setCoordinateIndices(0, indices);
		geometry.setColors(0, colors);
		geometry.setColorIndices(0, colorIndices);
				
		Shape3D door = new Shape3D(geometry);
		//ɥĤʬޤ
				
				
		//ɥμüʬʳ¦
		Point3d verticesN[] = new Point3d[16];
				
		double xN = 0.0;
		double yN = yLeng / 3.0;
		double zN = zLeng - 0.1;
		verticesN[0] = new Point3d(xN,       yN,                     zN        );//ɥΥָ
		verticesN[1] = new Point3d(xN,       yN,                     zN + 0.03 );
		verticesN[2] = new Point3d(xN,       yN + 0.03,              zN + 0.03 );
		verticesN[3] = new Point3d(xN,       yN + 0.03,              zN        );
		verticesN[4] = new Point3d(xN - 0.1, yN,                     zN        );
		verticesN[5] = new Point3d(xN - 0.1, yN,                     zN + 0.03 );
		verticesN[6] = new Point3d(xN - 0.07, yN + 0.03,             zN + 0.03 );
		verticesN[7] = new Point3d(xN - 0.07, yN + 0.03,             zN        );
		verticesN[8] = new Point3d(xN - 0.07, yN + yLeng/3.0 - 0.03, zN        );
		verticesN[9] = new Point3d(xN - 0.07, yN + yLeng/3.0 - 0.03, zN + 0.03 );
		verticesN[10] = new Point3d(xN - 0.1, yN + yLeng/3.0,        zN + 0.03 );
		verticesN[11] = new Point3d(xN - 0.1, yN + yLeng/3.0,        zN        );
		verticesN[12] = new Point3d(xN,       yN + yLeng/3.0 - 0.03, zN        );
		verticesN[13] = new Point3d(xN,       yN + yLeng/3.0 - 0.03, zN + 0.03 );
		verticesN[14] = new Point3d(xN,       yN + yLeng/3.0,        zN + 0.03 );
		verticesN[15] = new Point3d(xN,       yN + yLeng/3.0,        zN        );
				
		int[] indicesN = { 2,1,0,3,
						   7,6,2,3,
						   6,5,1,2,
						   5,4,0,1,
						   4,7,3,0,
								
						   11,4,5,10,
						   10,5,6,9,
						   9,6,7,8,
						   8,7,4,11,
								
						   14,13,12,15,
						   11,10,14,15,
						   10,9,13,14,
						   9,8,12,13,
						   8,11,15,12, };
								
		Color3f white = new Color3f(1.0f, 1.0f, 1.0f);
		Color3f white1 = new Color3f(0.9f, 0.9f, 0.9f);
		Color3f white2 = new Color3f(0.8f, 0.8f, 0.8f);
		Color3f[] colorsN = { white, white1, white2 };
				
		int[] colorIndicesN = { 0,0,0,0,
								2,2,2,2,
								1,1,1,1,
								2,2,2,2,
								1,1,1,1,
									
								0,0,0,0,
								1,1,1,1,
								2,2,2,2,
								1,1,1,1,
									
								0,0,0,0,
								2,2,2,2,
								1,1,1,1,
								2,2,2,2,
								1,1,1,1, };
				
				
		IndexedQuadArray geometryN = new IndexedQuadArray(verticesN.length,
														  GeometryArray.COORDINATES | GeometryArray.COLOR_3, indicesN.length);
		geometryN.setCoordinates(0, verticesN);
		geometryN.setCoordinateIndices(0, indicesN);
		geometryN.setColors(0, colorsN);
		geometryN.setColorIndices(0, colorIndicesN);
                                
		Shape3D nob = new Shape3D(geometryN);
		//ɥμüʬޤǡʳ¦
                                
		//ɥμüʬ¦
		Point3d verticesN2[] = new Point3d[16];
				
		double xN2 = xLeng;
		double yN2 = yLeng / 3.0;
		double zN2 = zLeng - 0.1;
		verticesN2[0] = new Point3d(xN2,       yN2,                     zN2        );//ɥΥָ
		verticesN2[1] = new Point3d(xN2,       yN2,                     zN2 + 0.03 );
		verticesN2[2] = new Point3d(xN2,       yN2 + 0.03,              zN2 + 0.03 );
		verticesN2[3] = new Point3d(xN2,       yN2 + 0.03,              zN2        );
		verticesN2[4] = new Point3d(xN2 + 0.1, yN2,                     zN2        );
		verticesN2[5] = new Point3d(xN2 + 0.1, yN2,                     zN2 + 0.03 );
		verticesN2[6] = new Point3d(xN2 + 0.07, yN2 + 0.03,             zN2 + 0.03 );
		verticesN2[7] = new Point3d(xN2 + 0.07, yN2 + 0.03,             zN2        );
		verticesN2[8] = new Point3d(xN2 + 0.07, yN2 + yLeng/3.0 - 0.03, zN2        );
		verticesN2[9] = new Point3d(xN2 + 0.07, yN2 + yLeng/3.0 - 0.03, zN2 + 0.03 );
		verticesN2[10] = new Point3d(xN2 + 0.1, yN2 + yLeng/3.0,        zN2 + 0.03 );
		verticesN2[11] = new Point3d(xN2 + 0.1, yN2 + yLeng/3.0,        zN2        );
		verticesN2[12] = new Point3d(xN2,       yN2 + yLeng/3.0 - 0.03, zN2        );
		verticesN2[13] = new Point3d(xN2,       yN2 + yLeng/3.0 - 0.03, zN2 + 0.03 );
		verticesN2[14] = new Point3d(xN2,       yN2 + yLeng/3.0,        zN2 + 0.03 );
		verticesN2[15] = new Point3d(xN2,       yN2 + yLeng/3.0,        zN2        );
				
		int[] indicesN2 = {3,0,1,2,
						   3,2,6,7,
						   2,1,5,6,
						   1,0,4,5,
						   0,3,7,4,
								
						   10,5,4,11,
						   9,6,5,10,
						   8,7,6,9,
						   11,4,7,8,
								
						   15,12,13,14,
						   15,14,10,11,
						   14,13,9,10,
						   13,12,8,9,
						   12,15,11,8, };
				
		Color3f[] colorsN2 = { white, white1, white2 };
				
		int[] colorIndicesN2 = { 0,0,0,0,
								 2,2,2,2,
								 1,1,1,1,
								 2,2,2,2,
								 1,1,1,1,
									
								 0,0,0,0,
								 1,1,1,1,
								 2,2,2,2,
								 1,1,1,1,
									
								 0,0,0,0,
								 2,2,2,2,
								 1,1,1,1,
								 2,2,2,2,
								 1,1,1,1, };
				
				
		IndexedQuadArray geometryN2 = new IndexedQuadArray(verticesN2.length,
														   GeometryArray.COORDINATES | GeometryArray.COLOR_3, indicesN2.length);
		geometryN2.setCoordinates(0, verticesN2);
		geometryN2.setCoordinateIndices(0, indicesN2);
		geometryN2.setColors(0, colorsN2);
		geometryN2.setColorIndices(0, colorIndicesN2);
                                
		Shape3D nob2 = new Shape3D(geometryN2);
		//ɥμüʬޤǡ¦
                                
                                
		//Transform3D rotation = new Transform3D();
		//rotation.setRotation(new AxisAngle4d(0.0, 1.0, 0.0, -hiraki));

		TransformGroup tr2 = new TransformGroup();
		tr2.addChild(door); //ɥʬ
		tr2.addChild(nob);  //ɥΥ֡곰¦
		tr2.addChild(nob2); //ɥΥ֡¦				
		bg.addChild(tr2);
				
		return bg;
	}

}
